Remove juju controller creation for LXD
[osm/devops.git] / installers / install_juju.sh
1 #!/bin/bash
2 #
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at
6 #
7 # http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14 #
15
16 function usage(){
17 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
18 echo -e "usage: $0 [OPTIONS]"
19 echo -e "Install Juju for OSM"
20 echo -e " OPTIONS"
21 echo -e " -h / --help: print this help"
22 echo -e " -D <devops path> use local devops installation path"
23 echo -e " -s <stack name> or <namespace> user defined stack name when installed using swarm or namespace when installed using k8s, default is osm"
24 echo -e " -H <VCA host> use specific juju host controller IP"
25 echo -e " -S <VCA secret> use VCA/juju secret key"
26 echo -e " -P <VCA pubkey> use VCA/juju public key file"
27 echo -e " -l: LXD cloud yaml file"
28 echo -e " -L: LXD credentials yaml file"
29 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
30 echo -e " --debug: debug mode"
31 echo -e " --cachelxdimages: cache local lxd images, create cronjob for that cache (will make installation longer)"
32 echo -e " --nojuju: do not juju, assumes already installed"
33 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
34 }
35
36 function update_juju_images(){
37 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
38 crontab -l | grep update-juju-lxc-images || (crontab -l 2>/dev/null; echo "0 4 * * 6 $USER ${OSM_DEVOPS}/installers/update-juju-lxc-images --xenial --bionic") | crontab -
39 ${OSM_DEVOPS}/installers/update-juju-lxc-images --xenial --bionic
40 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
41 }
42
43 function install_juju() {
44 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
45 echo "Installing juju"
46 sudo snap install juju --classic --channel=$JUJU_VERSION/stable
47 [[ ":$PATH": != *":/snap/bin:"* ]] && PATH="/snap/bin:${PATH}"
48 [ -n "$INSTALL_CACHELXDIMAGES" ] && update_juju_images
49 echo "Finished installation of juju"
50 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
51 return 0
52 }
53
54 function juju_createcontroller_k8s(){
55 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
56 cat $HOME/.kube/config | juju add-k8s $OSM_VCA_K8S_CLOUDNAME --client \
57 || FATAL "Failed to add K8s endpoint and credential for client in cloud $OSM_VCA_K8S_CLOUDNAME"
58 juju bootstrap -v --debug $OSM_VCA_K8S_CLOUDNAME $OSM_STACK_NAME \
59 --config controller-service-type=loadbalancer \
60 --agent-version=$JUJU_AGENT_VERSION \
61 || FATAL "Failed to bootstrap controller $OSM_STACK_NAME in cloud $OSM_VCA_K8S_CLOUDNAME"
62 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
63 }
64
65 function juju_addlxd_cloud(){
66 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
67 mkdir -p /tmp/.osm
68 OSM_VCA_CLOUDNAME="lxd-cloud"
69 LXDENDPOINT=$DEFAULT_IP
70 LXD_CLOUD=/tmp/.osm/lxd-cloud.yaml
71 LXD_CREDENTIALS=/tmp/.osm/lxd-credentials.yaml
72
73 cat << EOF > $LXD_CLOUD
74 clouds:
75 $OSM_VCA_CLOUDNAME:
76 type: lxd
77 auth-types: [certificate]
78 endpoint: "https://$LXDENDPOINT:8443"
79 config:
80 ssl-hostname-verification: false
81 EOF
82 openssl req -nodes -new -x509 -keyout /tmp/.osm/client.key -out /tmp/.osm/client.crt -days 365 -subj "/C=FR/ST=Nice/L=Nice/O=ETSI/OU=OSM/CN=osm.etsi.org"
83 local server_cert=`cat /var/snap/lxd/common/lxd/server.crt | sed 's/^/ /'`
84 local client_cert=`cat /tmp/.osm/client.crt | sed 's/^/ /'`
85 local client_key=`cat /tmp/.osm/client.key | sed 's/^/ /'`
86
87 cat << EOF > $LXD_CREDENTIALS
88 credentials:
89 $OSM_VCA_CLOUDNAME:
90 lxd-cloud:
91 auth-type: certificate
92 server-cert: |
93 $server_cert
94 client-cert: |
95 $client_cert
96 client-key: |
97 $client_key
98 EOF
99 lxc config trust add local: /tmp/.osm/client.crt
100 juju add-cloud -c $OSM_STACK_NAME $OSM_VCA_CLOUDNAME $LXD_CLOUD --force
101 juju add-credential -c $OSM_STACK_NAME $OSM_VCA_CLOUDNAME -f $LXD_CREDENTIALS
102 sg lxd -c "lxd waitready"
103 juju controller-config features=[k8s-operators]
104 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
105 }
106
107 #Safe unattended install of iptables-persistent
108 function check_install_iptables_persistent(){
109 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
110 echo -e "\nChecking required packages: iptables-persistent"
111 if ! dpkg -l iptables-persistent &>/dev/null; then
112 echo -e " Not installed.\nInstalling iptables-persistent requires root privileges"
113 echo iptables-persistent iptables-persistent/autosave_v4 boolean true | sudo debconf-set-selections
114 echo iptables-persistent iptables-persistent/autosave_v6 boolean true | sudo debconf-set-selections
115 sudo apt-get -yq install iptables-persistent
116 fi
117 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
118 }
119
120 function juju_createproxy() {
121 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
122 check_install_iptables_persistent
123
124 if ! sudo iptables -t nat -C PREROUTING -p tcp -m tcp -d $DEFAULT_IP --dport 17070 -j DNAT --to-destination $OSM_VCA_HOST; then
125 sudo iptables -t nat -A PREROUTING -p tcp -m tcp -d $DEFAULT_IP --dport 17070 -j DNAT --to-destination $OSM_VCA_HOST
126 sudo netfilter-persistent save
127 fi
128 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
129 }
130
131 DEBUG_INSTALL=""
132 INSTALL_CACHELXDIMAGES=""
133 INSTALL_NOJUJU=""
134 JUJU_AGENT_VERSION=2.9.22
135 JUJU_VERSION=2.9
136 OSM_DEVOPS=
137 OSM_STACK_NAME=osm
138 OSM_VCA_HOST=
139 OSM_VCA_CLOUDNAME="localhost"
140 OSM_VCA_K8S_CLOUDNAME="k8scloud"
141 RE_CHECK='^[a-z0-9]([-a-z0-9]*[a-z0-9])?$'
142
143 while getopts ":D:i:s:H:l:L:K:-: h" o; do
144 case "${o}" in
145 D)
146 OSM_DEVOPS="${OPTARG}"
147 ;;
148 i)
149 DEFAULT_IP="${OPTARG}"
150 ;;
151 s)
152 OSM_STACK_NAME="${OPTARG}" && [[ ! "${OPTARG}" =~ $RE_CHECK ]] && echo "Namespace $OPTARG is invalid. Regex used for validation is $RE_CHECK" && exit 0
153 ;;
154 H)
155 OSM_VCA_HOST="${OPTARG}"
156 ;;
157 l)
158 LXD_CLOUD_FILE="${OPTARG}"
159 ;;
160 L)
161 LXD_CRED_FILE="${OPTARG}"
162 ;;
163 K)
164 CONTROLLER_NAME="${OPTARG}"
165 ;;
166 -)
167 [ "${OPTARG}" == "help" ] && usage && exit 0
168 [ "${OPTARG}" == "debug" ] && DEBUG_INSTALL="--debug" && continue
169 [ "${OPTARG}" == "nojuju" ] && INSTALL_NOJUJU="y" && continue
170 [ "${OPTARG}" == "cachelxdimages" ] && INSTALL_CACHELXDIMAGES="y" && continue
171 echo -e "Invalid option: '--$OPTARG'\n" >&2
172 usage && exit 1
173 ;;
174 :)
175 echo "Option -$OPTARG requires an argument" >&2
176 usage && exit 1
177 ;;
178 \?)
179 echo -e "Invalid option: '-$OPTARG'\n" >&2
180 usage && exit 1
181 ;;
182 h)
183 usage && exit 0
184 ;;
185 *)
186 usage && exit 1
187 ;;
188 esac
189 done
190
191 source $OSM_DEVOPS/common/logging
192 source $OSM_DEVOPS/common/track
193
194 echo "DEBUG_INSTALL=$DEBUG_INSTALL"
195 echo "DEFAULT_IP=$DEFAULT_IP"
196 echo "OSM_DEVOPS=$OSM_DEVOPS"
197 echo "HOME=$HOME"
198
199 [ -z "$INSTALL_NOJUJU" ] && install_juju
200 track juju juju_install_ok
201
202 if [ -z "$OSM_VCA_HOST" ]; then
203 if [ -z "$CONTROLLER_NAME" ]; then
204 juju_createcontroller_k8s
205 juju_addlxd_cloud
206 if [ -n "$LXD_CLOUD_FILE" ]; then
207 [ -z "$LXD_CRED_FILE" ] && FATAL "The installer needs the LXD credential yaml if the LXD is external"
208 OSM_VCA_CLOUDNAME="lxd-cloud"
209 juju add-cloud $OSM_VCA_CLOUDNAME $LXD_CLOUD_FILE --force || juju update-cloud $OSM_VCA_CLOUDNAME --client -f $LXD_CLOUD_FILE
210 juju add-credential $OSM_VCA_CLOUDNAME -f $LXD_CRED_FILE || juju update-credential $OSM_VCA_CLOUDNAME lxd-cloud-creds -f $LXD_CRED_FILE
211 fi
212 juju_createproxy
213 else
214 OSM_VCA_CLOUDNAME="lxd-cloud"
215 if [ -n "$LXD_CLOUD_FILE" ]; then
216 [ -z "$LXD_CRED_FILE" ] && FATAL "The installer needs the LXD credential yaml if the LXD is external"
217 juju add-cloud -c $CONTROLLER_NAME $OSM_VCA_CLOUDNAME $LXD_CLOUD_FILE --force || juju update-cloud lxd-cloud -c $CONTROLLER_NAME -f $LXD_CLOUD_FILE
218 juju add-credential -c $CONTROLLER_NAME $OSM_VCA_CLOUDNAME -f $LXD_CRED_FILE || juju update-credential lxd-cloud -c $CONTROLLER_NAME -f $LXD_CRED_FILE
219 else
220 mkdir -p ~/.osm
221 cat << EOF > ~/.osm/lxd-cloud.yaml
222 clouds:
223 lxd-cloud:
224 type: lxd
225 auth-types: [certificate]
226 endpoint: "https://$DEFAULT_IP:8443"
227 config:
228 ssl-hostname-verification: false
229 EOF
230 openssl req -nodes -new -x509 -keyout ~/.osm/client.key -out ~/.osm/client.crt -days 365 -subj "/C=FR/ST=Nice/L=Nice/O=ETSI/OU=OSM/CN=osm.etsi.org"
231 local server_cert=`cat /var/snap/lxd/common/lxd/server.crt | sed 's/^/ /'`
232 local client_cert=`cat ~/.osm/client.crt | sed 's/^/ /'`
233 local client_key=`cat ~/.osm/client.key | sed 's/^/ /'`
234 cat << EOF > ~/.osm/lxd-credentials.yaml
235 credentials:
236 lxd-cloud:
237 lxd-cloud:
238 auth-type: certificate
239 server-cert: |
240 $server_cert
241 client-cert: |
242 $client_cert
243 client-key: |
244 $client_key
245 EOF
246 lxc config trust add local: ~/.osm/client.crt
247 juju add-cloud -c $CONTROLLER_NAME $OSM_VCA_CLOUDNAME ~/.osm/lxd-cloud.yaml --force || juju update-cloud lxd-cloud -c $CONTROLLER_NAME -f ~/.osm/lxd-cloud.yaml
248 juju add-credential -c $CONTROLLER_NAME $OSM_VCA_CLOUDNAME -f ~/.osm/lxd-credentials.yaml || juju update-credential lxd-cloud -c $CONTROLLER_NAME -f ~/.osm/lxd-credentials.yaml
249 fi
250 fi
251 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_HOST=`sg lxd -c "juju show-controller $OSM_STACK_NAME"|grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
252 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_HOST=`juju show-controller $CONTROLLER_NAME |grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
253 [ -z "$OSM_VCA_HOST" ] && FATAL "Cannot obtain juju controller IP address"
254 fi
255 track juju juju_controller_ok
256
257